import .bool
import .connectives
import .leibniz
import .logic
import .nat
def bigops.sameF_upto : forall (A : Type) , (nat.nat) -> ((nat.nat) -> A) -> ((nat.nat) -> A) -> Prop := fun (A : Type) , fun (k : nat.nat) , fun (f : (nat.nat) -> A) , fun (g : (nat.nat) -> A) , forall (i:nat.nat) , ((((nat.lt_) ) (i)) (k)) -> (((logic.eq_) (A)) ((f) (i))) ((g) (i)).
def bigops.sameF_p : forall (A : Type) , (nat.nat) -> ((nat.nat) -> bool.bool) -> ((nat.nat) -> A) -> ((nat.nat) -> A) -> Prop := fun (A : Type) , fun (k : nat.nat) , fun (p : (nat.nat) -> bool.bool) , fun (f : (nat.nat) -> A) , fun (g : (nat.nat) -> A) , forall (i:nat.nat) , ((((nat.lt_) ) (i)) (k)) -> ((((logic.eq_) (bool.bool)) ((p) (i))) ((bool.true) )) -> (((logic.eq_) (A)) ((f) (i))) ((g) (i)).
theorem bigops.sameF_upto_le : forall (A : Type) , forall (f:(nat.nat) -> A) , forall (g:(nat.nat) -> A) , forall (n:nat.nat) , forall (m:nat.nat) , ((((nat.le_) ) (n)) (m)) -> (((((bigops.sameF_upto) (A)) (m)) (f)) (g)) -> ((((bigops.sameF_upto) (A)) (n)) (f)) (g) := fun (A : Type) , fun (f : (nat.nat) -> A) , fun (g : (nat.nat) -> A) , fun (n : nat.nat) , fun (m : nat.nat) , fun (lenm : (((nat.le_) ) (n)) (m)) , (fun (samef : ((((bigops.sameF_upto) (A)) (m)) (f)) (g)) , (fun (i : nat.nat) , fun (ltin : (((nat.lt_) ) (i)) (n)) , (((samef) (i)) ((((((@nat.lt_to_le_to_lt) (i)) (n)) (m)) (ltin)) (lenm))))).
theorem bigops.sameF_p_le : forall (A : Type) , forall (p:(nat.nat) -> bool.bool) , forall (f:(nat.nat) -> A) , forall (g:(nat.nat) -> A) , forall (n:nat.nat) , forall (m:nat.nat) , ((((nat.le_) ) (n)) (m)) -> ((((((bigops.sameF_p) (A)) (m)) (p)) (f)) (g)) -> (((((bigops.sameF_p) (A)) (n)) (p)) (f)) (g) := fun (A : Type) , fun (p : (nat.nat) -> bool.bool) , fun (f : (nat.nat) -> A) , fun (g : (nat.nat) -> A) , fun (n : nat.nat) , fun (m : nat.nat) , fun (lenm : (((nat.le_) ) (n)) (m)) , (fun (samef : (((((bigops.sameF_p) (A)) (m)) (p)) (f)) (g)) , (fun (i : nat.nat) , fun (ltin : (((nat.lt_) ) (i)) (n)) , (fun (pi : (((logic.eq_) (bool.bool)) ((p) (i))) ((bool.true) )) , ((((samef) (i)) ((((((@nat.lt_to_le_to_lt) (i)) (n)) (m)) (ltin)) (lenm))) (((((((@logic.rewrite_r) (bool.bool)) ((bool.true) )) (fun (__ : bool.bool) , (((logic.eq_) (bool.bool)) (__)) ((bool.true) ))) (((@logic.refl_) (bool.bool)) ((bool.true) ))) ((p) (i))) (pi)))))).
constant bigops.bigop : forall (H : Type) , (nat.nat) -> ((nat.nat) -> bool.bool) -> (H) -> ((H) -> (H) -> H) -> ((nat.nat) -> H) -> H.
constant bigops.bigop_body : forall (H : Type) , (nat.nat) -> ((nat.nat) -> bool.bool) -> (H) -> ((H) -> (H) -> H) -> ((nat.nat) -> H) -> H.
axiom bigops.axiom_bigop_O : forall (H : Type) , (((connectives.equal) (((nat.nat) -> bool.bool) -> (H) -> ((H) -> (H) -> H) -> ((nat.nat) -> H) -> H)) (((bigops.bigop) (H)) ((nat.O) ))) (((bigops.bigop_body) (H)) ((nat.O) )).
theorem bigops.eq_bigop_O : forall (H : Type) , (((leibniz.leibniz) (((nat.nat) -> bool.bool) -> (H) -> ((H) -> (H) -> H) -> ((nat.nat) -> H) -> H)) (((bigops.bigop) (H)) ((nat.O) ))) (((bigops.bigop_body) (H)) ((nat.O) )) := fun (H : Type) , ((((@connectives.equal_leibniz) (((nat.nat) -> bool.bool) -> (H) -> ((H) -> (H) -> H) -> ((nat.nat) -> H) -> H)) (((bigops.bigop) (H)) ((nat.O) ))) (((bigops.bigop_body) (H)) ((nat.O) ))) ((@bigops.axiom_bigop_O) (H)).
theorem bigops.sym_eq_bigop_O : forall (H : Type) , (((leibniz.leibniz) (((nat.nat) -> bool.bool) -> (H) -> ((H) -> (H) -> H) -> ((nat.nat) -> H) -> H)) (((bigops.bigop_body) (H)) ((nat.O) ))) (((bigops.bigop) (H)) ((nat.O) )) := fun (H : Type) , ((((@leibniz.sym_leibniz) (((nat.nat) -> bool.bool) -> (H) -> ((H) -> (H) -> H) -> ((nat.nat) -> H) -> H)) (((bigops.bigop) (H)) ((nat.O) ))) (((bigops.bigop_body) (H)) ((nat.O) ))) ((@bigops.eq_bigop_O) (H)).
axiom bigops.axiom_bigop_S : forall (H : Type) , forall (n:nat.nat) , (((connectives.equal) (((nat.nat) -> bool.bool) -> (H) -> ((H) -> (H) -> H) -> ((nat.nat) -> H) -> H)) (((bigops.bigop) (H)) (((nat.S) ) (n)))) (((bigops.bigop_body) (H)) (((nat.S) ) (n))).
theorem bigops.eq_bigop_S : forall (H : Type) , forall (n:nat.nat) , (((leibniz.leibniz) (((nat.nat) -> bool.bool) -> (H) -> ((H) -> (H) -> H) -> ((nat.nat) -> H) -> H)) (((bigops.bigop) (H)) (((nat.S) ) (n)))) (((bigops.bigop_body) (H)) (((nat.S) ) (n))) := fun (H : Type) , fun (n : nat.nat) , ((((@connectives.equal_leibniz) (((nat.nat) -> bool.bool) -> (H) -> ((H) -> (H) -> H) -> ((nat.nat) -> H) -> H)) (((bigops.bigop) (H)) (((nat.S) ) (n)))) (((bigops.bigop_body) (H)) (((nat.S) ) (n)))) (((@bigops.axiom_bigop_S) (H)) (n)).
theorem bigops.sym_eq_bigop_S : forall (H : Type) , forall (n:nat.nat) , (((leibniz.leibniz) (((nat.nat) -> bool.bool) -> (H) -> ((H) -> (H) -> H) -> ((nat.nat) -> H) -> H)) (((bigops.bigop_body) (H)) (((nat.S) ) (n)))) (((bigops.bigop) (H)) (((nat.S) ) (n))) := fun (H : Type) , fun (n : nat.nat) , ((((@leibniz.sym_leibniz) (((nat.nat) -> bool.bool) -> (H) -> ((H) -> (H) -> H) -> ((nat.nat) -> H) -> H)) (((bigops.bigop) (H)) (((nat.S) ) (n)))) (((bigops.bigop_body) (H)) (((nat.S) ) (n)))) (((@bigops.eq_bigop_S) (H)) (n)).
axiom bigops.axiom_bigop_body_O : forall (H : Type) , (((connectives.equal) (((nat.nat) -> bool.bool) -> (H) -> ((H) -> (H) -> H) -> ((nat.nat) -> H) -> H)) (((bigops.bigop_body) (H)) ((nat.O) ))) (fun (p : (nat.nat) -> bool.bool) , fun (nil : H) , fun (op : (H) -> (H) -> H) , fun (f : (nat.nat) -> H) , nil).
theorem bigops.eq_bigop_body_O : forall (H : Type) , (((leibniz.leibniz) (((nat.nat) -> bool.bool) -> (H) -> ((H) -> (H) -> H) -> ((nat.nat) -> H) -> H)) (((bigops.bigop_body) (H)) ((nat.O) ))) (fun (p : (nat.nat) -> bool.bool) , fun (nil : H) , fun (op : (H) -> (H) -> H) , fun (f : (nat.nat) -> H) , nil) := fun (H : Type) , ((((@connectives.equal_leibniz) (((nat.nat) -> bool.bool) -> (H) -> ((H) -> (H) -> H) -> ((nat.nat) -> H) -> H)) (((bigops.bigop_body) (H)) ((nat.O) ))) (fun (p : (nat.nat) -> bool.bool) , fun (nil : H) , fun (op : (H) -> (H) -> H) , fun (f : (nat.nat) -> H) , nil)) ((@bigops.axiom_bigop_body_O) (H)).
theorem bigops.sym_eq_bigop_body_O : forall (H : Type) , (((leibniz.leibniz) (((nat.nat) -> bool.bool) -> (H) -> ((H) -> (H) -> H) -> ((nat.nat) -> H) -> H)) (fun (p : (nat.nat) -> bool.bool) , fun (nil : H) , fun (op : (H) -> (H) -> H) , fun (f : (nat.nat) -> H) , nil)) (((bigops.bigop_body) (H)) ((nat.O) )) := fun (H : Type) , ((((@leibniz.sym_leibniz) (((nat.nat) -> bool.bool) -> (H) -> ((H) -> (H) -> H) -> ((nat.nat) -> H) -> H)) (((bigops.bigop_body) (H)) ((nat.O) ))) (fun (p : (nat.nat) -> bool.bool) , fun (nil : H) , fun (op : (H) -> (H) -> H) , fun (f : (nat.nat) -> H) , nil)) ((@bigops.eq_bigop_body_O) (H)).
axiom bigops.axiom_bigop_body_S : forall (H : Type) , forall (n:nat.nat) , (((connectives.equal) (((nat.nat) -> bool.bool) -> (H) -> ((H) -> (H) -> H) -> ((nat.nat) -> H) -> H)) (((bigops.bigop_body) (H)) (((nat.S) ) (n)))) (fun (p : (nat.nat) -> bool.bool) , fun (nil : H) , fun (op : (H) -> (H) -> H) , fun (f : (nat.nat) -> H) , ((((bool.match_bool_type) (H)) (((op) ((f) (n))) (((((((bigops.bigop) (H)) (n)) (p)) (nil)) (op)) (f)))) (((((((bigops.bigop) (H)) (n)) (p)) (nil)) (op)) (f))) ((p) (n))).
theorem bigops.eq_bigop_body_S : forall (H : Type) , forall (n:nat.nat) , (((leibniz.leibniz) (((nat.nat) -> bool.bool) -> (H) -> ((H) -> (H) -> H) -> ((nat.nat) -> H) -> H)) (((bigops.bigop_body) (H)) (((nat.S) ) (n)))) (fun (p : (nat.nat) -> bool.bool) , fun (nil : H) , fun (op : (H) -> (H) -> H) , fun (f : (nat.nat) -> H) , ((((bool.match_bool_type) (H)) (((op) ((f) (n))) (((((((bigops.bigop) (H)) (n)) (p)) (nil)) (op)) (f)))) (((((((bigops.bigop) (H)) (n)) (p)) (nil)) (op)) (f))) ((p) (n))) := fun (H : Type) , fun (n : nat.nat) , ((((@connectives.equal_leibniz) (((nat.nat) -> bool.bool) -> (H) -> ((H) -> (H) -> H) -> ((nat.nat) -> H) -> H)) (((bigops.bigop_body) (H)) (((nat.S) ) (n)))) (fun (p : (nat.nat) -> bool.bool) , fun (nil : H) , fun (op : (H) -> (H) -> H) , fun (f : (nat.nat) -> H) , ((((bool.match_bool_type) (H)) (((op) ((f) (n))) (((((((bigops.bigop) (H)) (n)) (p)) (nil)) (op)) (f)))) (((((((bigops.bigop) (H)) (n)) (p)) (nil)) (op)) (f))) ((p) (n)))) (((@bigops.axiom_bigop_body_S) (H)) (n)).
theorem bigops.sym_eq_bigop_body_S : forall (H : Type) , forall (n:nat.nat) , (((leibniz.leibniz) (((nat.nat) -> bool.bool) -> (H) -> ((H) -> (H) -> H) -> ((nat.nat) -> H) -> H)) (fun (p : (nat.nat) -> bool.bool) , fun (nil : H) , fun (op : (H) -> (H) -> H) , fun (f : (nat.nat) -> H) , ((((bool.match_bool_type) (H)) (((op) ((f) (n))) (((((((bigops.bigop) (H)) (n)) (p)) (nil)) (op)) (f)))) (((((((bigops.bigop) (H)) (n)) (p)) (nil)) (op)) (f))) ((p) (n)))) (((bigops.bigop_body) (H)) (((nat.S) ) (n))) := fun (H : Type) , fun (n : nat.nat) , ((((@leibniz.sym_leibniz) (((nat.nat) -> bool.bool) -> (H) -> ((H) -> (H) -> H) -> ((nat.nat) -> H) -> H)) (((bigops.bigop_body) (H)) (((nat.S) ) (n)))) (fun (p : (nat.nat) -> bool.bool) , fun (nil : H) , fun (op : (H) -> (H) -> H) , fun (f : (nat.nat) -> H) , ((((bool.match_bool_type) (H)) (((op) ((f) (n))) (((((((bigops.bigop) (H)) (n)) (p)) (nil)) (op)) (f)))) (((((((bigops.bigop) (H)) (n)) (p)) (nil)) (op)) (f))) ((p) (n)))) (((@bigops.eq_bigop_body_S) (H)) (n)).
theorem bigops.bigop_Strue : forall (B : Type) , forall (k:nat.nat) , forall (p:(nat.nat) -> bool.bool) , forall (nil:B) , forall (op:(B) -> (B) -> B) , forall (f:(nat.nat) -> B) , ((((logic.eq_) (bool.bool)) ((p) (k))) ((bool.true) )) -> (((logic.eq_) (B)) (((((((bigops.bigop) (B)) (((nat.S) ) (k))) (fun (i : nat.nat) , (p) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) (((op) ((f) (k))) (((((((bigops.bigop) (B)) (k)) (fun (i : nat.nat) , (p) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) := fun (B : Type) , fun (k : nat.nat) , fun (p : (nat.nat) -> bool.bool) , fun (nil : B) , fun (op : (B) -> (B) -> B) , fun (f : (nat.nat) -> B) , ((((@bigops.sym_eq_bigop_S) (B)) (k)) (fun (y : ((nat.nat) -> bool.bool) -> (B) -> ((B) -> (B) -> B) -> ((nat.nat) -> B) -> B) , ((((logic.eq_) (bool.bool)) ((p) (k))) ((bool.true) )) -> (((logic.eq_) (B)) (((((y) (fun (i : nat.nat) , (p) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) (((op) ((f) (k))) (((((((bigops.bigop) (B)) (k)) (fun (i : nat.nat) , (p) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))))) (((((@bigops.sym_eq_bigop_body_S) (B)) (k)) (fun (y : ((nat.nat) -> bool.bool) -> (B) -> ((B) -> (B) -> B) -> ((nat.nat) -> B) -> B) , ((((logic.eq_) (bool.bool)) ((p) (k))) ((bool.true) )) -> (((logic.eq_) (B)) (((((y) (fun (i : nat.nat) , (p) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) (((op) ((f) (k))) (((((((bigops.bigop) (B)) (k)) (fun (i : nat.nat) , (p) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))))) (fun (H : (((logic.eq_) (bool.bool)) ((p) (k))) ((bool.true) )) , (((((((@logic.eq_ind_r) (bool.bool)) ((bool.true) )) (fun (x : bool.bool) , (((logic.eq_) (B)) (((((bool.match_bool_type) (B)) (((op) ((f) (k))) (((((((bigops.bigop) (B)) (k)) (fun (i : nat.nat) , (p) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i))))) (((((((bigops.bigop) (B)) (k)) (fun (i : nat.nat) , (p) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) (x))) (((op) ((f) (k))) (((((((bigops.bigop) (B)) (k)) (fun (i : nat.nat) , (p) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))))) ((((((@bool.eq_match_bool_type_true) (B)) (((op) ((f) (k))) (((((((bigops.bigop) (B)) (k)) (fun (i : nat.nat) , (p) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i))))) (((((((bigops.bigop) (B)) (k)) (fun (i : nat.nat) , (p) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) (fun (y : B) , (((logic.eq_) (B)) (((((bool.match_bool_type) (B)) (((op) ((f) (k))) (((((((bigops.bigop) (B)) (k)) (fun (i : nat.nat) , (p) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i))))) (((((((bigops.bigop) (B)) (k)) (fun (i : nat.nat) , (p) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) ((bool.true) ))) (y))) (((@logic.refl_) (B)) (((((bool.match_bool_type) (B)) (((op) ((f) (k))) (((((((bigops.bigop) (B)) (k)) (fun (i : nat.nat) , (p) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i))))) (((((((bigops.bigop) (B)) (k)) (fun (i : nat.nat) , (p) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) ((bool.true) ))))) ((p) (k))) (H)))).
theorem bigops.bigop_Sfalse : forall (B : Type) , forall (k:nat.nat) , forall (p:(nat.nat) -> bool.bool) , forall (nil:B) , forall (op:(B) -> (B) -> B) , forall (f:(nat.nat) -> B) , ((((logic.eq_) (bool.bool)) ((p) (k))) ((bool.false) )) -> (((logic.eq_) (B)) (((((((bigops.bigop) (B)) (((nat.S) ) (k))) (fun (i : nat.nat) , (p) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) (((((((bigops.bigop) (B)) (k)) (fun (i : nat.nat) , (p) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i))) := fun (B : Type) , fun (k : nat.nat) , fun (p : (nat.nat) -> bool.bool) , fun (nil : B) , fun (op : (B) -> (B) -> B) , fun (f : (nat.nat) -> B) , ((((@bigops.sym_eq_bigop_S) (B)) (k)) (fun (y : ((nat.nat) -> bool.bool) -> (B) -> ((B) -> (B) -> B) -> ((nat.nat) -> B) -> B) , ((((logic.eq_) (bool.bool)) ((p) (k))) ((bool.false) )) -> (((logic.eq_) (B)) (((((y) (fun (i : nat.nat) , (p) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) (((((((bigops.bigop) (B)) (k)) (fun (i : nat.nat) , (p) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i))))) (((((@bigops.sym_eq_bigop_body_S) (B)) (k)) (fun (y : ((nat.nat) -> bool.bool) -> (B) -> ((B) -> (B) -> B) -> ((nat.nat) -> B) -> B) , ((((logic.eq_) (bool.bool)) ((p) (k))) ((bool.false) )) -> (((logic.eq_) (B)) (((((y) (fun (i : nat.nat) , (p) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) (((((((bigops.bigop) (B)) (k)) (fun (i : nat.nat) , (p) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i))))) (fun (H : (((logic.eq_) (bool.bool)) ((p) (k))) ((bool.false) )) , (((((((@logic.eq_ind_r) (bool.bool)) ((bool.false) )) (fun (x : bool.bool) , (((logic.eq_) (B)) (((((bool.match_bool_type) (B)) (((op) ((f) (k))) (((((((bigops.bigop) (B)) (k)) (fun (i : nat.nat) , (p) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i))))) (((((((bigops.bigop) (B)) (k)) (fun (i : nat.nat) , (p) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) (x))) (((((((bigops.bigop) (B)) (k)) (fun (i : nat.nat) , (p) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i))))) ((((((@bool.eq_match_bool_type_false) (B)) (((op) ((f) (k))) (((((((bigops.bigop) (B)) (k)) (fun (i : nat.nat) , (p) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i))))) (((((((bigops.bigop) (B)) (k)) (fun (i : nat.nat) , (p) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) (fun (y : B) , (((logic.eq_) (B)) (((((bool.match_bool_type) (B)) (((op) ((f) (k))) (((((((bigops.bigop) (B)) (k)) (fun (i : nat.nat) , (p) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i))))) (((((((bigops.bigop) (B)) (k)) (fun (i : nat.nat) , (p) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) ((bool.false) ))) (y))) (((@logic.refl_) (B)) (((((bool.match_bool_type) (B)) (((op) ((f) (k))) (((((((bigops.bigop) (B)) (k)) (fun (i : nat.nat) , (p) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i))))) (((((((bigops.bigop) (B)) (k)) (fun (i : nat.nat) , (p) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) ((bool.false) ))))) ((p) (k))) (H)))).
theorem bigops.same_bigop : forall (B : Type) , forall (k:nat.nat) , forall (p1:(nat.nat) -> bool.bool) , forall (p2:(nat.nat) -> bool.bool) , forall (nil:B) , forall (op:(B) -> (B) -> B) , forall (f:(nat.nat) -> B) , forall (g:(nat.nat) -> B) , (((((bigops.sameF_upto) (bool.bool)) (k)) (p1)) (p2)) -> ((((((bigops.sameF_p) (B)) (k)) (p1)) (f)) (g)) -> (((logic.eq_) (B)) (((((((bigops.bigop) (B)) (k)) (fun (i : nat.nat) , (p1) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) (((((((bigops.bigop) (B)) (k)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i))) := fun (B : Type) , fun (k : nat.nat) , fun (p1 : (nat.nat) -> bool.bool) , fun (p2 : (nat.nat) -> bool.bool) , fun (nil : B) , fun (op : (B) -> (B) -> B) , fun (f : (nat.nat) -> B) , fun (g : (nat.nat) -> B) , ((((@nat.nat_ind) (fun (_x_365 : nat.nat) , (((((bigops.sameF_upto) (bool.bool)) (_x_365)) (p1)) (p2)) -> ((((((bigops.sameF_p) (B)) (_x_365)) (p1)) (f)) (g)) -> (((logic.eq_) (B)) (((((((bigops.bigop) (B)) (_x_365)) (fun (i : nat.nat) , (p1) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) (((((((bigops.bigop) (B)) (_x_365)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i))))) ((((@bigops.sym_eq_bigop_O) (B)) (fun (y : ((nat.nat) -> bool.bool) -> (B) -> ((B) -> (B) -> B) -> ((nat.nat) -> B) -> B) , (((((bigops.sameF_upto) (bool.bool)) ((nat.O) )) (p1)) (p2)) -> ((((((bigops.sameF_p) (B)) ((nat.O) )) (p1)) (f)) (g)) -> (((logic.eq_) (B)) (((((((bigops.bigop) (B)) ((nat.O) )) (fun (i : nat.nat) , (p1) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) (((((y) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i))))) ((((@bigops.sym_eq_bigop_body_O) (B)) (fun (y : ((nat.nat) -> bool.bool) -> (B) -> ((B) -> (B) -> B) -> ((nat.nat) -> B) -> B) , (((((bigops.sameF_upto) (bool.bool)) ((nat.O) )) (p1)) (p2)) -> ((((((bigops.sameF_p) (B)) ((nat.O) )) (p1)) (f)) (g)) -> (((logic.eq_) (B)) (((((((bigops.bigop) (B)) ((nat.O) )) (fun (i : nat.nat) , (p1) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) (((((y) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i))))) ((((@bigops.eq_bigop_body_O) (B)) (fun (y : ((nat.nat) -> bool.bool) -> (B) -> ((B) -> (B) -> B) -> ((nat.nat) -> B) -> B) , (((((bigops.sameF_upto) (bool.bool)) ((nat.O) )) (p1)) (p2)) -> ((((((bigops.sameF_p) (B)) ((nat.O) )) (p1)) (f)) (g)) -> (((logic.eq_) (B)) (((((((bigops.bigop) (B)) ((nat.O) )) (fun (i : nat.nat) , (p1) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) (((((y) (fun (i : nat.nat) , (p1) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i))))) ((((@bigops.eq_bigop_O) (B)) (fun (y : ((nat.nat) -> bool.bool) -> (B) -> ((B) -> (B) -> B) -> ((nat.nat) -> B) -> B) , (((((bigops.sameF_upto) (bool.bool)) ((nat.O) )) (p1)) (p2)) -> ((((((bigops.sameF_p) (B)) ((nat.O) )) (p1)) (f)) (g)) -> (((logic.eq_) (B)) (((((((bigops.bigop) (B)) ((nat.O) )) (fun (i : nat.nat) , (p1) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) (((((y) (fun (i : nat.nat) , (p1) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i))))) (fun (auto : ((((bigops.sameF_upto) (bool.bool)) ((nat.O) )) (p1)) (p2)) , (fun (auto' : (((((bigops.sameF_p) (B)) ((nat.O) )) (p1)) (f)) (g)) , (((@logic.refl_) (B)) (((((((bigops.bigop) (B)) ((nat.O) )) (fun (i : nat.nat) , (p1) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i))))))))))) (fun (n : nat.nat) , ((((@bigops.sym_eq_bigop_S) (B)) (n)) (fun (y : ((nat.nat) -> bool.bool) -> (B) -> ((B) -> (B) -> B) -> ((nat.nat) -> B) -> B) , ((((((bigops.sameF_upto) (bool.bool)) (n)) (p1)) (p2)) -> ((((((bigops.sameF_p) (B)) (n)) (p1)) (f)) (g)) -> (((logic.eq_) (B)) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p1) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i)))) -> (((((bigops.sameF_upto) (bool.bool)) (((nat.S) ) (n))) (p1)) (p2)) -> ((((((bigops.sameF_p) (B)) (((nat.S) ) (n))) (p1)) (f)) (g)) -> (((logic.eq_) (B)) (((((((bigops.bigop) (B)) (((nat.S) ) (n))) (fun (i : nat.nat) , (p1) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) (((((y) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i))))) (((((@bigops.sym_eq_bigop_S) (B)) (n)) (fun (y : ((nat.nat) -> bool.bool) -> (B) -> ((B) -> (B) -> B) -> ((nat.nat) -> B) -> B) , ((((((bigops.sameF_upto) (bool.bool)) (n)) (p1)) (p2)) -> ((((((bigops.sameF_p) (B)) (n)) (p1)) (f)) (g)) -> (((logic.eq_) (B)) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p1) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i)))) -> (((((bigops.sameF_upto) (bool.bool)) (((nat.S) ) (n))) (p1)) (p2)) -> ((((((bigops.sameF_p) (B)) (((nat.S) ) (n))) (p1)) (f)) (g)) -> (((logic.eq_) (B)) (((((y) (fun (i : nat.nat) , (p1) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) (((((((bigops.bigop_body) (B)) (((nat.S) ) (n))) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i))))) (((((@bigops.sym_eq_bigop_body_S) (B)) (n)) (fun (y : ((nat.nat) -> bool.bool) -> (B) -> ((B) -> (B) -> B) -> ((nat.nat) -> B) -> B) , ((((((bigops.sameF_upto) (bool.bool)) (n)) (p1)) (p2)) -> ((((((bigops.sameF_p) (B)) (n)) (p1)) (f)) (g)) -> (((logic.eq_) (B)) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p1) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i)))) -> (((((bigops.sameF_upto) (bool.bool)) (((nat.S) ) (n))) (p1)) (p2)) -> ((((((bigops.sameF_p) (B)) (((nat.S) ) (n))) (p1)) (f)) (g)) -> (((logic.eq_) (B)) (((((y) (fun (i : nat.nat) , (p1) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) (((((((bigops.bigop_body) (B)) (((nat.S) ) (n))) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i))))) (((((@bigops.sym_eq_bigop_body_S) (B)) (n)) (fun (y : ((nat.nat) -> bool.bool) -> (B) -> ((B) -> (B) -> B) -> ((nat.nat) -> B) -> B) , ((((((bigops.sameF_upto) (bool.bool)) (n)) (p1)) (p2)) -> ((((((bigops.sameF_p) (B)) (n)) (p1)) (f)) (g)) -> (((logic.eq_) (B)) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p1) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i)))) -> (((((bigops.sameF_upto) (bool.bool)) (((nat.S) ) (n))) (p1)) (p2)) -> ((((((bigops.sameF_p) (B)) (((nat.S) ) (n))) (p1)) (f)) (g)) -> (((logic.eq_) (B)) ((((((fun (p : (nat.nat) -> bool.bool) , fun (nil0 : B) , fun (op0 : (B) -> (B) -> B) , fun (f0 : (nat.nat) -> B) , ((((bool.match_bool_type) (B)) (((op0) ((f0) (n))) (((((((bigops.bigop) (B)) (n)) (p)) (nil0)) (op0)) (f0)))) (((((((bigops.bigop) (B)) (n)) (p)) (nil0)) (op0)) (f0))) ((p) (n))) (fun (i : nat.nat) , (p1) (i)))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) (((((y) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i))))) (fun (Hind : (((((bigops.sameF_upto) (bool.bool)) (n)) (p1)) (p2)) -> ((((((bigops.sameF_p) (B)) (n)) (p1)) (f)) (g)) -> (((logic.eq_) (B)) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p1) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i)))) , (fun (samep : ((((bigops.sameF_upto) (bool.bool)) (((nat.S) ) (n))) (p1)) (p2)) , (fun (samef : (((((bigops.sameF_p) (B)) (((nat.S) ) (n))) (p1)) (f)) (g)) , (((((((@logic.eq_ind_r) (B)) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i)))) (fun (x : B) , (((logic.eq_) (B)) (((((bool.match_bool_type) (B)) (((op) ((f) (n))) (x))) (x)) ((p1) (n)))) (((((bool.match_bool_type) (B)) (((op) ((g) (n))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i))))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i)))) ((p2) (n))))) (((((((@logic.eq_ind) (bool.bool)) ((p1) (n))) (fun (x_1 : bool.bool) , (((logic.eq_) (B)) (((((bool.match_bool_type) (B)) (((op) ((f) (n))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i))))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i)))) ((p1) (n)))) (((((bool.match_bool_type) (B)) (((op) ((g) (n))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i))))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i)))) (x_1)))) (((((((@connectives.match_Or_prop) ((((logic.eq_) (bool.bool)) ((p1) (n))) ((bool.true) ))) ((((logic.eq_) (bool.bool)) ((p1) (n))) ((bool.false) ))) ((((logic.eq_) (B)) (((((bool.match_bool_type) (B)) (((op) ((f) (n))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i))))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i)))) ((p1) (n)))) (((((bool.match_bool_type) (B)) (((op) ((g) (n))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i))))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i)))) ((p1) (n))))) (fun (H1 : (((logic.eq_) (bool.bool)) ((p1) (n))) ((bool.true) )) , (((((((@logic.eq_ind_r) (bool.bool)) ((bool.true) )) (fun (x : bool.bool) , (((logic.eq_) (B)) (((((bool.match_bool_type) (B)) (((op) ((f) (n))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i))))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i)))) (x))) (((((bool.match_bool_type) (B)) (((op) ((g) (n))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i))))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i)))) (x)))) ((((((@bool.sym_eq_match_bool_type_true) (B)) (((op) ((f) (n))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i))))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i)))) (fun (y : B) , (((logic.eq_) (B)) (y)) (((((bool.match_bool_type) (B)) (((op) ((g) (n))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i))))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i)))) ((bool.true) )))) ((((((@bool.sym_eq_match_bool_type_true) (B)) (((op) ((g) (n))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i))))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i)))) (fun (y : B) , (((logic.eq_) (B)) (((op) ((f) (n))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i))))) (y))) (((((((@logic.eq_ind) (B)) ((f) (n))) (fun (x_1 : B) , (((logic.eq_) (B)) (((op) ((f) (n))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i))))) (((op) (x_1)) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i)))))) (((@logic.refl_) (B)) (((op) ((f) (n))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i)))))) ((g) (n))) ((((samef) (n)) ((@nat.le_n) (((nat.S) ) (n)))) (H1)))))) ((p1) (n))) (H1)))) (fun (H1 : (((logic.eq_) (bool.bool)) ((p1) (n))) ((bool.false) )) , (((((((@logic.eq_ind_r) (bool.bool)) ((bool.false) )) (fun (x : bool.bool) , (((logic.eq_) (B)) (((((bool.match_bool_type) (B)) (((op) ((f) (n))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i))))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i)))) (x))) (((((bool.match_bool_type) (B)) (((op) ((g) (n))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i))))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i)))) (x)))) ((((((@bool.sym_eq_match_bool_type_false) (B)) (((op) ((f) (n))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i))))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i)))) (fun (y : B) , (((logic.eq_) (B)) (y)) (((((bool.match_bool_type) (B)) (((op) ((g) (n))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i))))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i)))) ((bool.false) )))) ((((((@bool.sym_eq_match_bool_type_false) (B)) (((op) ((g) (n))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i))))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i)))) (fun (y : B) , (((logic.eq_) (B)) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i)))) (y))) (((@logic.refl_) (B)) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i))))))) ((p1) (n))) (H1)))) ((@bool.true_or_false) ((p1) (n))))) ((p2) (n))) (((samep) (n)) ((@nat.le_n) (((nat.S) ) (n)))))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p1) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) (((Hind) ((((((((@bigops.sameF_upto_le) (bool.bool)) (p1)) (p2)) (n)) (((nat.S) ) (n))) (((((@logic.eq_coerc) ((((nat.le_) ) (((nat.pred_) ) (((nat.S) ) (n)))) (((nat.S) ) (n)))) ((((nat.le_) ) (n)) (((nat.S) ) (n)))) ((@nat.le_pred_n) (((nat.S) ) (n)))) (((((((@logic.rewrite_l) (nat.nat)) (n)) (fun (__ : nat.nat) , (((logic.eq_) (Prop)) ((((nat.le_) ) (__)) (((nat.S) ) (n)))) ((((nat.le_) ) (n)) (((nat.S) ) (n))))) (((@logic.refl_) (Prop)) ((((nat.le_) ) (n)) (((nat.S) ) (n))))) (((nat.pred_) ) (((nat.S) ) (n)))) ((@nat.pred_Sn) (n))))) (samep))) (((((((((@bigops.sameF_p_le) (B)) (p1)) (f)) (g)) (n)) (((nat.S) ) (n))) (((((@logic.eq_coerc) ((((nat.le_) ) (((nat.pred_) ) (((nat.S) ) (n)))) (((nat.S) ) (n)))) ((((nat.le_) ) (n)) (((nat.S) ) (n)))) ((@nat.le_pred_n) (((nat.S) ) (n)))) (((((((@logic.rewrite_l) (nat.nat)) (n)) (fun (__ : nat.nat) , (((logic.eq_) (Prop)) ((((nat.le_) ) (__)) (((nat.S) ) (n)))) ((((nat.le_) ) (n)) (((nat.S) ) (n))))) (((@logic.refl_) (Prop)) ((((nat.le_) ) (n)) (((nat.S) ) (n))))) (((nat.pred_) ) (((nat.S) ) (n)))) ((@nat.pred_Sn) (n))))) (samef)))))))))))) (k).
theorem bigops.assoc : forall (a:nat.nat) , forall (b:nat.nat) , forall (c:nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.times) ) (a)) ((((nat.times) ) (b)) (c)))) ((((nat.times) ) ((((nat.times) ) (a)) (b))) (c)) := fun (a : nat.nat) , fun (b : nat.nat) , fun (c : nat.nat) , ((((@logic.sym_eq) (nat.nat)) ((((nat.times) ) ((((nat.times) ) (a)) (b))) (c))) ((((nat.times) ) (a)) ((((nat.times) ) (b)) (c)))) ((((@nat.associative_times) (a)) (b)) (c)).
theorem bigops.bigop_diff : forall (p:(nat.nat) -> bool.bool) , forall (f:(nat.nat) -> nat.nat) , forall (i:nat.nat) , forall (n:nat.nat) , ((((nat.lt_) ) (i)) (n)) -> ((((logic.eq_) (bool.bool)) ((p) (i))) ((bool.true) )) -> (((logic.eq_) (nat.nat)) (((((((bigops.bigop) (nat.nat)) (n)) (fun (x : nat.nat) , (p) (x))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (x : nat.nat) , (f) (x)))) ((((nat.times) ) ((f) (i))) (((((((bigops.bigop) (nat.nat)) (n)) (fun (x : nat.nat) , (((bool.andb) ) (((bool.notb) ) ((((nat.eqb) ) (i)) (x)))) ((p) (x)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (x : nat.nat) , (f) (x)))) := fun (p : (nat.nat) -> bool.bool) , fun (f : (nat.nat) -> nat.nat) , fun (i : nat.nat) , fun (n : nat.nat) , ((((@nat.nat_ind) (fun (_x_365 : nat.nat) , ((((nat.lt_) ) (i)) (_x_365)) -> ((((logic.eq_) (bool.bool)) ((p) (i))) ((bool.true) )) -> (((logic.eq_) (nat.nat)) (((((((bigops.bigop) (nat.nat)) (_x_365)) (fun (x : nat.nat) , (p) (x))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (x : nat.nat) , (f) (x)))) ((((nat.times) ) ((f) (i))) (((((((bigops.bigop) (nat.nat)) (_x_365)) (fun (x : nat.nat) , (((bool.andb) ) (((bool.notb) ) ((((nat.eqb) ) (i)) (x)))) ((p) (x)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (x : nat.nat) , (f) (x)))))) (fun (ltO : (((nat.lt_) ) (i)) ((nat.O) )) , (((@connectives.falsity) (((((logic.eq_) (bool.bool)) ((p) (i))) ((bool.true) )) -> (((logic.eq_) (nat.nat)) (((((((bigops.bigop) (nat.nat)) ((nat.O) )) (fun (x : nat.nat) , (p) (x))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (x : nat.nat) , (f) (x)))) ((((nat.times) ) ((f) (i))) (((((((bigops.bigop) (nat.nat)) ((nat.O) )) (fun (x : nat.nat) , (((bool.andb) ) (((bool.notb) ) ((((nat.eqb) ) (i)) (x)))) ((p) (x)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (x : nat.nat) , (f) (x)))))) ((((@logic.absurd) ((((nat.le_) ) (((nat.S) ) (i))) ((nat.O) ))) (ltO)) ((@nat.not_le_Sn_O) (i)))))) (fun (n0 : nat.nat) , fun (Hind : ((((nat.lt_) ) (i)) (n0)) -> ((((logic.eq_) (bool.bool)) ((p) (i))) ((bool.true) )) -> (((logic.eq_) (nat.nat)) (((((((bigops.bigop) (nat.nat)) (n0)) (fun (x : nat.nat) , (p) (x))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (x : nat.nat) , (f) (x)))) ((((nat.times) ) ((f) (i))) (((((((bigops.bigop) (nat.nat)) (n0)) (fun (x : nat.nat) , (((bool.andb) ) (((bool.notb) ) ((((nat.eqb) ) (i)) (x)))) ((p) (x)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (x : nat.nat) , (f) (x))))) , (fun (lein : (((nat.lt_) ) (i)) (((nat.S) ) (n0))) , (fun (pi : (((logic.eq_) (bool.bool)) ((p) (i))) ((bool.true) )) , (((((((@connectives.match_Or_prop) ((((nat.lt_) ) (i)) (n0))) ((((logic.eq_) (nat.nat)) (i)) (n0))) ((((logic.eq_) (nat.nat)) (((((((bigops.bigop) (nat.nat)) (((nat.S) ) (n0))) (fun (x : nat.nat) , (p) (x))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (x : nat.nat) , (f) (x)))) ((((nat.times) ) ((f) (i))) (((((((bigops.bigop) (nat.nat)) (((nat.S) ) (n0))) (fun (x : nat.nat) , (((bool.andb) ) (((bool.notb) ) ((((nat.eqb) ) (i)) (x)))) ((p) (x)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (x : nat.nat) , (f) (x)))))) (fun (Hi : (((nat.lt_) ) (i)) (n0)) , (((((((@connectives.match_Or_prop) ((((logic.eq_) (bool.bool)) ((p) (n0))) ((bool.true) ))) ((((logic.eq_) (bool.bool)) ((p) (n0))) ((bool.false) ))) ((((logic.eq_) (nat.nat)) (((((((bigops.bigop) (nat.nat)) (((nat.S) ) (n0))) (fun (x : nat.nat) , (p) (x))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (x : nat.nat) , (f) (x)))) ((((nat.times) ) ((f) (i))) (((((((bigops.bigop) (nat.nat)) (((nat.S) ) (n0))) (fun (x : nat.nat) , (((bool.andb) ) (((bool.notb) ) ((((nat.eqb) ) (i)) (x)))) ((p) (x)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (x : nat.nat) , (f) (x)))))) (fun (pn : (((logic.eq_) (bool.bool)) ((p) (n0))) ((bool.true) )) , (((((((@logic.eq_ind_r) (nat.nat)) ((((nat.times) ) ((f) (n0))) (((((((bigops.bigop) (nat.nat)) (n0)) (fun (i0 : nat.nat) , (p) (i0))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i0 : nat.nat) , (f) (i0))))) (fun (x : nat.nat) , (((logic.eq_) (nat.nat)) (x)) ((((nat.times) ) ((f) (i))) (((((((bigops.bigop) (nat.nat)) (((nat.S) ) (n0))) (fun (x0 : nat.nat) , (((bool.andb) ) (((bool.notb) ) ((((nat.eqb) ) (i)) (x0)))) ((p) (x0)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (x0 : nat.nat) , (f) (x0)))))) (((((((@logic.eq_ind_r) (nat.nat)) ((((nat.times) ) ((f) (n0))) (((((((bigops.bigop) (nat.nat)) (n0)) (fun (i0 : nat.nat) , (((bool.andb) ) (((bool.notb) ) ((((nat.eqb) ) (i)) (i0)))) ((p) (i0)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i0 : nat.nat) , (f) (i0))))) (fun (x : nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.times) ) ((f) (n0))) (((((((bigops.bigop) (nat.nat)) (n0)) (fun (i0 : nat.nat) , (p) (i0))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i0 : nat.nat) , (f) (i0))))) ((((nat.times) ) ((f) (i))) (x)))) (((((((@logic.eq_ind_r) (nat.nat)) ((((nat.times) ) ((((nat.times) ) ((f) (i))) ((f) (n0)))) (((((((bigops.bigop) (nat.nat)) (n0)) (fun (i0 : nat.nat) , ((((bool.match_bool_type) (bool.bool)) ((p) (i0))) ((bool.false) )) (((((bool.match_bool_type) (bool.bool)) ((bool.false) )) ((bool.true) )) ((((nat.eqb) ) (i)) (i0))))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i0 : nat.nat) , (f) (i0))))) (fun (x : nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.times) ) ((f) (n0))) (((((((bigops.bigop) (nat.nat)) (n0)) (fun (i0 : nat.nat) , (p) (i0))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i0 : nat.nat) , (f) (i0))))) (x))) (((((((@logic.eq_ind_r) (nat.nat)) ((((nat.times) ) ((f) (n0))) ((f) (i)))) (fun (x : nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.times) ) ((f) (n0))) (((((((bigops.bigop) (nat.nat)) (n0)) (fun (i0 : nat.nat) , (p) (i0))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i0 : nat.nat) , (f) (i0))))) ((((nat.times) ) (x)) (((((((bigops.bigop) (nat.nat)) (n0)) (fun (i0 : nat.nat) , ((((bool.match_bool_type) (bool.bool)) ((p) (i0))) ((bool.false) )) (((((bool.match_bool_type) (bool.bool)) ((bool.false) )) ((bool.true) )) ((((nat.eqb) ) (i)) (i0))))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i0 : nat.nat) , (f) (i0)))))) (((((((@logic.eq_ind) (nat.nat)) ((((nat.times) ) ((f) (n0))) ((((nat.times) ) ((f) (i))) (((((((bigops.bigop) (nat.nat)) (n0)) (fun (i0 : nat.nat) , ((((bool.match_bool_type) (bool.bool)) ((p) (i0))) ((bool.false) )) (((((bool.match_bool_type) (bool.bool)) ((bool.false) )) ((bool.true) )) ((((nat.eqb) ) (i)) (i0))))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i0 : nat.nat) , (f) (i0)))))) (fun (x_1 : nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.times) ) ((f) (n0))) (((((((bigops.bigop) (nat.nat)) (n0)) (fun (i0 : nat.nat) , (p) (i0))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i0 : nat.nat) , (f) (i0))))) (x_1))) (((((((@logic.eq_ind_r) (nat.nat)) ((((nat.times) ) ((f) (i))) (((((((bigops.bigop) (nat.nat)) (n0)) (fun (x : nat.nat) , (((bool.andb) ) (((bool.notb) ) ((((nat.eqb) ) (i)) (x)))) ((p) (x)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (x : nat.nat) , (f) (x))))) (fun (x : nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.times) ) ((f) (n0))) (x))) ((((nat.times) ) ((f) (n0))) ((((nat.times) ) ((f) (i))) (((((((bigops.bigop) (nat.nat)) (n0)) (fun (i0 : nat.nat) , ((((bool.match_bool_type) (bool.bool)) ((p) (i0))) ((bool.false) )) (((((bool.match_bool_type) (bool.bool)) ((bool.false) )) ((bool.true) )) ((((nat.eqb) ) (i)) (i0))))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i0 : nat.nat) , (f) (i0))))))) (((@logic.refl_) (nat.nat)) ((((nat.times) ) ((f) (n0))) ((((nat.times) ) ((f) (i))) (((((((bigops.bigop) (nat.nat)) (n0)) (fun (x : nat.nat) , (((bool.andb) ) (((bool.notb) ) ((((nat.eqb) ) (i)) (x)))) ((p) (x)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (x : nat.nat) , (f) (x))))))) (((((((bigops.bigop) (nat.nat)) (n0)) (fun (x : nat.nat) , (p) (x))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (x : nat.nat) , (f) (x)))) (((Hind) (Hi)) (((((((@logic.rewrite_r) (bool.bool)) ((bool.true) )) (fun (__ : bool.bool) , (((logic.eq_) (bool.bool)) (__)) ((bool.true) ))) (((@logic.refl_) (bool.bool)) ((bool.true) ))) ((p) (i))) (pi))))) ((((nat.times) ) ((((nat.times) ) ((f) (n0))) ((f) (i)))) (((((((bigops.bigop) (nat.nat)) (n0)) (fun (i0 : nat.nat) , ((((bool.match_bool_type) (bool.bool)) ((p) (i0))) ((bool.false) )) (((((bool.match_bool_type) (bool.bool)) ((bool.false) )) ((bool.true) )) ((((nat.eqb) ) (i)) (i0))))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i0 : nat.nat) , (f) (i0))))) ((((@bigops.assoc) ((f) (n0))) ((f) (i))) (((((((bigops.bigop) (nat.nat)) (n0)) (fun (i0 : nat.nat) , ((((bool.match_bool_type) (bool.bool)) ((p) (i0))) ((bool.false) )) (((((bool.match_bool_type) (bool.bool)) ((bool.false) )) ((bool.true) )) ((((nat.eqb) ) (i)) (i0))))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i0 : nat.nat) , (f) (i0)))))) ((((nat.times) ) ((f) (i))) ((f) (n0)))) (((@nat.commutative_times) ((f) (i))) ((f) (n0))))) ((((nat.times) ) ((f) (i))) ((((nat.times) ) ((f) (n0))) (((((((bigops.bigop) (nat.nat)) (n0)) (fun (i0 : nat.nat) , ((((bool.match_bool_type) (bool.bool)) ((p) (i0))) ((bool.false) )) (((((bool.match_bool_type) (bool.bool)) ((bool.false) )) ((bool.true) )) ((((nat.eqb) ) (i)) (i0))))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i0 : nat.nat) , (f) (i0)))))) ((((@bigops.assoc) ((f) (i))) ((f) (n0))) (((((((bigops.bigop) (nat.nat)) (n0)) (fun (i0 : nat.nat) , ((((bool.match_bool_type) (bool.bool)) ((p) (i0))) ((bool.false) )) (((((bool.match_bool_type) (bool.bool)) ((bool.false) )) ((bool.true) )) ((((nat.eqb) ) (i)) (i0))))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i0 : nat.nat) , (f) (i0)))))) (((((((bigops.bigop) (nat.nat)) (((nat.S) ) (n0))) (fun (i0 : nat.nat) , (((bool.andb) ) (((bool.notb) ) ((((nat.eqb) ) (i)) (i0)))) ((p) (i0)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i0 : nat.nat) , (f) (i0)))) ((((((((@bigops.bigop_Strue) (nat.nat)) (n0)) (fun (__ : nat.nat) , (((bool.andb) ) (((bool.notb) ) ((((nat.eqb) ) (i)) (__)))) ((p) (__)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (f)) (((((((@logic.rewrite_r) (bool.bool)) ((bool.true) )) (fun (__ : bool.bool) , (((logic.eq_) (bool.bool)) ((((bool.andb) ) (((bool.notb) ) ((((nat.eqb) ) (i)) (n0)))) (__))) ((bool.true) ))) (((((((@logic.rewrite_r) (bool.bool)) ((bool.true) )) (fun (__ : bool.bool) , (((logic.eq_) (bool.bool)) (__)) ((bool.true) ))) (((@logic.refl_) (bool.bool)) ((bool.true) ))) ((((bool.andb) ) (((bool.notb) ) ((((nat.eqb) ) (i)) (n0)))) ((bool.true) ))) (((((((@logic.rewrite_l) (bool.bool)) ((p) (n0))) (fun (__ : bool.bool) , (((logic.eq_) (bool.bool)) ((((bool.andb) ) (((bool.notb) ) ((((nat.eqb) ) (i)) (n0)))) ((bool.true) ))) (__))) (((((((@logic.rewrite_l) (bool.bool)) ((p) (n0))) (fun (__ : bool.bool) , (((logic.eq_) (bool.bool)) ((((bool.andb) ) (((bool.notb) ) ((((nat.eqb) ) (i)) (n0)))) (__))) ((p) (n0)))) (((((((@logic.eq_ind_r) (bool.bool)) ((bool.false) )) (fun (x : bool.bool) , (((logic.eq_) (bool.bool)) ((((bool.andb) ) (((bool.notb) ) (x))) ((p) (n0)))) ((p) (n0)))) ((((((@bool.sym_eq_match_bool_type_false) (bool.bool)) ((bool.false) )) ((bool.true) )) (fun (y : bool.bool) , (((logic.eq_) (bool.bool)) (((((bool.match_bool_type) (bool.bool)) ((p) (n0))) ((bool.false) )) (y))) ((p) (n0)))) ((((((@bool.eq_match_bool_type_true) (bool.bool)) ((p) (n0))) ((bool.false) )) (fun (y : bool.bool) , (((logic.eq_) (bool.bool)) (((((bool.match_bool_type) (bool.bool)) ((p) (n0))) ((bool.false) )) ((bool.true) ))) (y))) ((((((@bool.eq_match_bool_type_false) (bool.bool)) ((bool.false) )) ((bool.true) )) (fun (y : bool.bool) , (((logic.eq_) (bool.bool)) (((((bool.match_bool_type) (bool.bool)) ((p) (n0))) ((bool.false) )) ((bool.true) ))) (((((bool.match_bool_type) (bool.bool)) ((p) (n0))) ((bool.false) )) (y)))) ((((((@bool.eq_match_bool_type_false) (bool.bool)) ((bool.false) )) ((bool.true) )) (fun (y : bool.bool) , (((logic.eq_) (bool.bool)) (((((bool.match_bool_type) (bool.bool)) ((p) (n0))) ((bool.false) )) (y))) (((((bool.match_bool_type) (bool.bool)) ((p) (n0))) ((bool.false) )) (((((bool.match_bool_type) (bool.bool)) ((bool.false) )) ((bool.true) )) ((bool.false) ))))) (((@logic.refl_) (bool.bool)) ((((bool.andb) ) (((bool.notb) ) ((bool.false) ))) ((p) (n0))))))))) ((((nat.eqb) ) (i)) (n0))) ((((@nat.not_eq_to_eqb_false) (i)) (n0)) ((((@nat.lt_to_not_eq) (i)) (n0)) (Hi))))) ((bool.true) )) (pn))) ((bool.true) )) (pn)))) ((p) (n0))) (pn))))) (((((((bigops.bigop) (nat.nat)) (((nat.S) ) (n0))) (fun (i0 : nat.nat) , (p) (i0))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i0 : nat.nat) , (f) (i0)))) ((((((((@bigops.bigop_Strue) (nat.nat)) (n0)) (p)) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (f)) (((((((@logic.rewrite_r) (bool.bool)) ((bool.true) )) (fun (__ : bool.bool) , (((logic.eq_) (bool.bool)) (__)) ((bool.true) ))) (((@logic.refl_) (bool.bool)) ((bool.true) ))) ((p) (n0))) (pn)))))) (fun (pn : (((logic.eq_) (bool.bool)) ((p) (n0))) ((bool.false) )) , (((((((@logic.eq_ind_r) (nat.nat)) (((((((bigops.bigop) (nat.nat)) (n0)) (fun (i0 : nat.nat) , (p) (i0))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i0 : nat.nat) , (f) (i0)))) (fun (x : nat.nat) , (((logic.eq_) (nat.nat)) (x)) ((((nat.times) ) ((f) (i))) (((((((bigops.bigop) (nat.nat)) (((nat.S) ) (n0))) (fun (x0 : nat.nat) , (((bool.andb) ) (((bool.notb) ) ((((nat.eqb) ) (i)) (x0)))) ((p) (x0)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (x0 : nat.nat) , (f) (x0)))))) (((((((@logic.eq_ind_r) (nat.nat)) (((((((bigops.bigop) (nat.nat)) (n0)) (fun (i0 : nat.nat) , (((bool.andb) ) (((bool.notb) ) ((((nat.eqb) ) (i)) (i0)))) ((p) (i0)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i0 : nat.nat) , (f) (i0)))) (fun (x : nat.nat) , (((logic.eq_) (nat.nat)) (((((((bigops.bigop) (nat.nat)) (n0)) (fun (i0 : nat.nat) , (p) (i0))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i0 : nat.nat) , (f) (i0)))) ((((nat.times) ) ((f) (i))) (x)))) (((((((@logic.eq_ind_r) (nat.nat)) ((((nat.times) ) ((f) (i))) (((((((bigops.bigop) (nat.nat)) (n0)) (fun (x : nat.nat) , (((bool.andb) ) (((bool.notb) ) ((((nat.eqb) ) (i)) (x)))) ((p) (x)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (x : nat.nat) , (f) (x))))) (fun (x : nat.nat) , (((logic.eq_) (nat.nat)) (x)) ((((nat.times) ) ((f) (i))) (((((((bigops.bigop) (nat.nat)) (n0)) (fun (i0 : nat.nat) , (((bool.andb) ) (((bool.notb) ) ((((nat.eqb) ) (i)) (i0)))) ((p) (i0)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i0 : nat.nat) , (f) (i0)))))) (((@logic.refl_) (nat.nat)) ((((nat.times) ) ((f) (i))) (((((((bigops.bigop) (nat.nat)) (n0)) (fun (x : nat.nat) , (((bool.andb) ) (((bool.notb) ) ((((nat.eqb) ) (i)) (x)))) ((p) (x)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (x : nat.nat) , (f) (x)))))) (((((((bigops.bigop) (nat.nat)) (n0)) (fun (x : nat.nat) , (p) (x))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (x : nat.nat) , (f) (x)))) (((Hind) (Hi)) (((((((@logic.rewrite_r) (bool.bool)) ((bool.true) )) (fun (__ : bool.bool) , (((logic.eq_) (bool.bool)) (__)) ((bool.true) ))) (((@logic.refl_) (bool.bool)) ((bool.true) ))) ((p) (i))) (pi))))) (((((((bigops.bigop) (nat.nat)) (((nat.S) ) (n0))) (fun (i0 : nat.nat) , (((bool.andb) ) (((bool.notb) ) ((((nat.eqb) ) (i)) (i0)))) ((p) (i0)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i0 : nat.nat) , (f) (i0)))) ((((((((@bigops.bigop_Sfalse) (nat.nat)) (n0)) (fun (__ : nat.nat) , (((bool.andb) ) (((bool.notb) ) ((((nat.eqb) ) (i)) (__)))) ((p) (__)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (f)) (((((((@logic.rewrite_r) (bool.bool)) ((bool.false) )) (fun (__ : bool.bool) , (((logic.eq_) (bool.bool)) ((((bool.andb) ) (((bool.notb) ) ((((nat.eqb) ) (i)) (n0)))) (__))) ((bool.false) ))) (((((((@logic.rewrite_r) (bool.bool)) ((bool.false) )) (fun (__ : bool.bool) , (((logic.eq_) (bool.bool)) (__)) ((bool.false) ))) (((@logic.refl_) (bool.bool)) ((bool.false) ))) ((((bool.andb) ) (((bool.notb) ) ((((nat.eqb) ) (i)) (n0)))) ((bool.false) ))) (((((((@logic.rewrite_l) (bool.bool)) ((p) (n0))) (fun (__ : bool.bool) , (((logic.eq_) (bool.bool)) ((((bool.andb) ) (((bool.notb) ) ((((nat.eqb) ) (i)) (n0)))) ((bool.false) ))) (__))) (((((((@logic.rewrite_l) (bool.bool)) ((p) (n0))) (fun (__ : bool.bool) , (((logic.eq_) (bool.bool)) ((((bool.andb) ) (((bool.notb) ) ((((nat.eqb) ) (i)) (n0)))) (__))) ((p) (n0)))) (((((((@logic.eq_ind_r) (bool.bool)) ((bool.false) )) (fun (x : bool.bool) , (((logic.eq_) (bool.bool)) ((((bool.andb) ) (((bool.notb) ) (x))) ((p) (n0)))) ((p) (n0)))) ((((((@bool.sym_eq_match_bool_type_false) (bool.bool)) ((bool.false) )) ((bool.true) )) (fun (y : bool.bool) , (((logic.eq_) (bool.bool)) (((((bool.match_bool_type) (bool.bool)) ((p) (n0))) ((bool.false) )) (y))) ((p) (n0)))) ((((((@bool.eq_match_bool_type_true) (bool.bool)) ((p) (n0))) ((bool.false) )) (fun (y : bool.bool) , (((logic.eq_) (bool.bool)) (((((bool.match_bool_type) (bool.bool)) ((p) (n0))) ((bool.false) )) ((bool.true) ))) (y))) ((((((@bool.eq_match_bool_type_false) (bool.bool)) ((bool.false) )) ((bool.true) )) (fun (y : bool.bool) , (((logic.eq_) (bool.bool)) (((((bool.match_bool_type) (bool.bool)) ((p) (n0))) ((bool.false) )) ((bool.true) ))) (((((bool.match_bool_type) (bool.bool)) ((p) (n0))) ((bool.false) )) (y)))) ((((((@bool.eq_match_bool_type_false) (bool.bool)) ((bool.false) )) ((bool.true) )) (fun (y : bool.bool) , (((logic.eq_) (bool.bool)) (((((bool.match_bool_type) (bool.bool)) ((p) (n0))) ((bool.false) )) (y))) (((((bool.match_bool_type) (bool.bool)) ((p) (n0))) ((bool.false) )) (((((bool.match_bool_type) (bool.bool)) ((bool.false) )) ((bool.true) )) ((bool.false) ))))) (((@logic.refl_) (bool.bool)) ((((bool.andb) ) (((bool.notb) ) ((bool.false) ))) ((p) (n0))))))))) ((((nat.eqb) ) (i)) (n0))) ((((@nat.not_eq_to_eqb_false) (i)) (n0)) ((((@nat.lt_to_not_eq) (i)) (n0)) (Hi))))) ((bool.false) )) (pn))) ((bool.false) )) (pn)))) ((p) (n0))) (pn))))) (((((((bigops.bigop) (nat.nat)) (((nat.S) ) (n0))) (fun (i0 : nat.nat) , (p) (i0))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i0 : nat.nat) , (f) (i0)))) ((((((((@bigops.bigop_Sfalse) (nat.nat)) (n0)) (p)) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (f)) (((((((@logic.rewrite_r) (bool.bool)) ((bool.false) )) (fun (__ : bool.bool) , (((logic.eq_) (bool.bool)) (__)) ((bool.false) ))) (((@logic.refl_) (bool.bool)) ((bool.false) ))) ((p) (n0))) (pn)))))) ((@bool.true_or_false) ((p) (n0)))))) (fun (Hi : (((logic.eq_) (nat.nat)) (i)) (n0)) , (((((((@logic.eq_ind) (nat.nat)) (i)) (fun (x_1 : nat.nat) , (((logic.eq_) (nat.nat)) (((((((bigops.bigop) (nat.nat)) (((nat.S) ) (x_1))) (fun (x : nat.nat) , (p) (x))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (x : nat.nat) , (f) (x)))) ((((nat.times) ) ((f) (i))) (((((((bigops.bigop) (nat.nat)) (((nat.S) ) (x_1))) (fun (x : nat.nat) , (((bool.andb) ) (((bool.notb) ) ((((nat.eqb) ) (i)) (x)))) ((p) (x)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (x : nat.nat) , (f) (x)))))) (((((((@logic.eq_ind_r) (nat.nat)) ((((nat.times) ) ((f) (i))) (((((((bigops.bigop) (nat.nat)) (i)) (fun (i0 : nat.nat) , (p) (i0))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i0 : nat.nat) , (f) (i0))))) (fun (x : nat.nat) , (((logic.eq_) (nat.nat)) (x)) ((((nat.times) ) ((f) (i))) (((((((bigops.bigop) (nat.nat)) (((nat.S) ) (i))) (fun (x0 : nat.nat) , (((bool.andb) ) (((bool.notb) ) ((((nat.eqb) ) (i)) (x0)))) ((p) (x0)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (x0 : nat.nat) , (f) (x0)))))) (((((((@logic.eq_f) (nat.nat)) (nat.nat)) (((nat.times) ) ((f) (i)))) (((((((bigops.bigop) (nat.nat)) (i)) (fun (i0 : nat.nat) , (p) (i0))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i0 : nat.nat) , (f) (i0)))) (((((((bigops.bigop) (nat.nat)) (((nat.S) ) (i))) (fun (x : nat.nat) , (((bool.andb) ) (((bool.notb) ) ((((nat.eqb) ) (i)) (x)))) ((p) (x)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (x : nat.nat) , (f) (x)))) (((((((@logic.eq_ind_r) (nat.nat)) (((((((bigops.bigop) (nat.nat)) (i)) (fun (i0 : nat.nat) , (((bool.andb) ) (((bool.notb) ) ((((nat.eqb) ) (i)) (i0)))) ((p) (i0)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i0 : nat.nat) , (f) (i0)))) (fun (x : nat.nat) , (((logic.eq_) (nat.nat)) (((((((bigops.bigop) (nat.nat)) (i)) (fun (i0 : nat.nat) , (p) (i0))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i0 : nat.nat) , (f) (i0)))) (x))) (((((((((((@bigops.same_bigop) (nat.nat)) (i)) (p)) (fun (__ : nat.nat) , (((bool.andb) ) (((bool.notb) ) ((((nat.eqb) ) (i)) (__)))) ((p) (__)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (f)) (f)) (fun (k : nat.nat) , fun (ltki : (((nat.lt_) ) (k)) (i)) , (((((((@logic.eq_ind_r) (bool.bool)) ((bool.false) )) (fun (x : bool.bool) , (((logic.eq_) (bool.bool)) ((p) (k))) ((((bool.andb) ) (((bool.notb) ) (x))) ((p) (k))))) ((((((@bool.sym_eq_match_bool_type_false) (bool.bool)) ((bool.false) )) ((bool.true) )) (fun (y : bool.bool) , (((logic.eq_) (bool.bool)) ((p) (k))) (((((bool.match_bool_type) (bool.bool)) ((p) (k))) ((bool.false) )) (y)))) ((((((@bool.sym_eq_match_bool_type_true) (bool.bool)) ((p) (k))) ((bool.false) )) (fun (y : bool.bool) , (((logic.eq_) (bool.bool)) ((p) (k))) (y))) (((@logic.refl_) (bool.bool)) ((p) (k)))))) ((((nat.eqb) ) (i)) (k))) ((((@nat.not_eq_to_eqb_false) (i)) (k)) (((((@logic.not_to_not) ((((logic.eq_) (nat.nat)) (i)) (k))) ((((nat.le_) ) (((nat.S) ) (i))) (i))) (fun (auto : (((logic.eq_) (nat.nat)) (i)) (k)) , (((((@logic.eq_coerc) ((((nat.le_) ) (((nat.S) ) (k))) (i))) ((((nat.le_) ) (((nat.S) ) (i))) (i))) (ltki)) (((((((@logic.rewrite_l) (nat.nat)) (i)) (fun (__ : nat.nat) , (((logic.eq_) (Prop)) ((((nat.le_) ) (((nat.S) ) (__))) (i))) ((((nat.le_) ) (((nat.S) ) (i))) (i)))) (((@logic.refl_) (Prop)) ((((nat.le_) ) (((nat.S) ) (i))) (i)))) (k)) (auto))))) ((@nat.not_le_Sn_n) (i))))))) (fun (i0 : nat.nat) , fun (auto : (((nat.lt_) ) (i0)) (i)) , (fun (auto' : (((logic.eq_) (bool.bool)) ((p) (i0))) ((bool.true) )) , (((@logic.refl_) (nat.nat)) ((f) (i0))))))) (((((((bigops.bigop) (nat.nat)) (((nat.S) ) (i))) (fun (i0 : nat.nat) , (((bool.andb) ) (((bool.notb) ) ((((nat.eqb) ) (i)) (i0)))) ((p) (i0)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i0 : nat.nat) , (f) (i0)))) ((((((((@bigops.bigop_Sfalse) (nat.nat)) (i)) (fun (__ : nat.nat) , (((bool.andb) ) (((bool.notb) ) ((((nat.eqb) ) (i)) (__)))) ((p) (__)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (f)) (((((((@logic.eq_ind_r) (bool.bool)) ((bool.true) )) (fun (x : bool.bool) , (((logic.eq_) (bool.bool)) ((((bool.andb) ) (((bool.notb) ) (x))) ((p) (i)))) ((bool.false) ))) ((((((@bool.eq_match_bool_type_false) (bool.bool)) ((p) (i))) ((bool.false) )) (fun (y : bool.bool) , (((logic.eq_) (bool.bool)) (((((bool.match_bool_type) (bool.bool)) ((p) (i))) ((bool.false) )) (((((bool.match_bool_type) (bool.bool)) ((bool.false) )) ((bool.true) )) ((bool.true) )))) (y))) ((((((@bool.eq_match_bool_type_true) (bool.bool)) ((bool.false) )) ((bool.true) )) (fun (y : bool.bool) , (((logic.eq_) (bool.bool)) (((((bool.match_bool_type) (bool.bool)) ((p) (i))) ((bool.false) )) (((((bool.match_bool_type) (bool.bool)) ((bool.false) )) ((bool.true) )) ((bool.true) )))) (((((bool.match_bool_type) (bool.bool)) ((p) (i))) ((bool.false) )) (y)))) (((@logic.refl_) (bool.bool)) ((((bool.andb) ) (((bool.notb) ) ((bool.true) ))) ((p) (i))))))) ((((nat.eqb) ) (i)) (i))) ((((@nat.eq_to_eqb_true) (i)) (i)) (((@logic.refl_) (nat.nat)) (i)))))))) (((((((bigops.bigop) (nat.nat)) (((nat.S) ) (i))) (fun (i0 : nat.nat) , (p) (i0))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i0 : nat.nat) , (f) (i0)))) ((((((((@bigops.bigop_Strue) (nat.nat)) (i)) (p)) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (f)) (((((((@logic.rewrite_r) (bool.bool)) ((bool.true) )) (fun (__ : bool.bool) , (((logic.eq_) (bool.bool)) (__)) ((bool.true) ))) (((@logic.refl_) (bool.bool)) ((bool.true) ))) ((p) (i))) (pi))))) (n0)) (Hi)))) ((((@nat.le_to_or_lt_eq) (i)) (n0)) ((((@nat.le_S_S_to_le) (i)) (n0)) (lein)))))))) (n).
